#include "ir_learn.h"
#include "pwm.h"
#include <EEPROM.h>

#define IR_PORT 2
#define BUTT_PORT 11
#define LED_PORT 13
#define IR_OUT 3

unsigned long time[256];
int i=-1;

void save()
{
  unsigned char * data;
  data=(unsigned char *)time;
  for(int addr=0;addr<1024;++addr)
  {
    EEPROM.write(addr, data[addr]);
  }
  Serial.println("Saved.");
}

void load()
{
  unsigned char * data;
  data=(unsigned char *)time;
  for(int addr=0;addr<1024;++addr)
  {
    data[addr]=EEPROM.read(addr);
  }
  for(int j=0;j<256;++j)
  {
    if (time[j]>=10000)
    {
      i=-1;
      break;
    }
    if (time[j]==0)
    {
      i=j;
      break;
    }
  }
  Serial.println("Loaded: ");
  for (int j=0;j<=i;++j)
  {
    Serial.print(j);
    Serial.print(": ");
    Serial.println(time[j]);
  }
  Serial.println("END");
}

void setFreq(int khz) {
  TIMER_DISABLE_INTR; //Timer2 Overflow Interrupt
  pinMode(IR_OUT, OUTPUT);
  digitalWrite(IR_OUT, LOW); // When not sending PWM, we want it low
  TIMER_CONFIG_KHZ(khz);
}

void learn()
{
  i=-1;
  Serial.println("Waiting for signal...");
  while(digitalRead(IR_PORT));
  //digitalWrite(13,HIGH);
  while(true)
  {
    time[++i]=micros();
    while(!digitalRead(IR_PORT));
    time[++i]=micros();
    while(digitalRead(IR_PORT) && micros()-time[i]<10000);
    if (micros()-time[i]>=10000)
    {
      break;
    }
  }
  //digitalWrite(13,LOW);
  /*for (unsigned int j=0;j<=i;++j)
  {
    Serial.print(j);
    Serial.print(": ");
    Serial.println(time[j]);
  }
  Serial.println("END");*/
  for (int j=0;j<i;++j)
  {
    time[j]=time[j+1]-time[j];
  }
  time[i]=0;
  save();
  Serial.println("Learnt: ");
  for (int j=0;j<=i;++j)
  {
    Serial.print(j);
    Serial.print(": ");
    Serial.println(time[j]);
  }
  Serial.println("END");
  /*for (unsigned int j=0;j<i;++j)
  {
    time[j]/=2*DELAY_TIME;
  }*/
}

void replay()
{
  if (i==-1) return;
  setFreq(38);
  Serial.println("replay!");
  for (int j=0;j<i;j+=2)
  {
    TIMER_ENABLE_PWM;
    delayMicroseconds(time[j]);
    TIMER_DISABLE_PWM;
    delayMicroseconds(time[j+1]);
    unsigned long H=time[j]+1,L=time[j+1]+1;
  }
}

void setup()
{
  Serial.begin(9600);
  pinMode(IR_PORT, INPUT);
  pinMode(BUTT_PORT,INPUT);
  pinMode(LED_PORT,OUTPUT);
  mymain();
}

void loop()
{
  //nope~
}

void testbutton()
{
  if (digitalRead(BUTT_PORT))
  {
    delay(50); //anti-jitter
    if (digitalRead(BUTT_PORT))
    {
      digitalWrite(LED_PORT,HIGH);
      learn();
      digitalWrite(LED_PORT,LOW);
    }
  }
}

void doActuator()
{
  if (false) //some con.
  {
    replay();
  }
}

void mymain()
{
  load();
  if (i<1)
  {
    Serial.println("No data, will learn...");
    learn();
  }
  else
  {
    while(1)
    {
      testbutton();
      doActuator();
    }
  }
}
